define(['app', 'js/utils/tips'], function(app, Tips) {
    app.controller('callbackCtrl', ['$scope', 'Storage', '$ionicHistory', 'httpRequest', '$state',
        function($scope, Storage, $ionicHistory, httpRequest, $state) {

            $scope.$on("$ionicView.beforeEnter", function() {
                $scope.feedback = {
                    content: ''
                }
            })

            $scope.back = function() {
                $ionicHistory.goBack();
            }

            $scope.submit = function() {
                var auth = Storage.get("DM_Auth");
                if (auth) {
                    var params = {
                        doctor_id: auth.doctor_id,
                        token: auth.token,
                        content: $scope.feedback.content
                    }
                } else {
                    var params = {
                        content: $scope.feedback.content
                    }
                }

                if (params.content == '') {
                    Tips.showTips('反馈内容不能为空');
                    return;
                }
                $scope.$emit('loadding', 'noBackdrop', '提交中...');
                httpRequest.post('doctor/api/PostFeedback', params, function(re, data) {
                    $scope.$emit('loadding', 'false');
                    if (data.code == 0) {
                        $scope.feedback.content = "";
                        Tips.showTips('提交成功');
                        $ionicHistory.goBack();
                    } else {
                        Tips.showTips(data.msg);
                    }
                }, function(re, data, sta) {
                    $scope.$emit('loadding', 'false');
                    console.log(re)
                });
            }

        }
    ]);
});

