define(['app','js/utils/tips'],function (app,Tips) {

    app.controller('commentDetailCtrl', ['$scope', 'httpRequest', '$state', function($scope, httpRequest, $state) {
        $scope.id = $state.params.id;
        $scope.data = [];
        $scope.timestamp = Math.ceil(new Date().getTime()/1000);
        $scope.loadOver = false;
        // 获取数据
        $scope.getData = function(){
            // http://192.168.1.201:8080/
            httpRequest.getWithAuth($scope, "doctor/api/GetArticleCommentList",{article_id: $scope.id, count:10, timestamp: $scope.timestamp}, function( re){
                re = re.data;
                if(!re.code){                
                    $scope.data = $scope.data.concat(re.data.comments);
                    if(re.data.comments){
                        if(re.data.comments.length < 10){
                            $scope.loadOver = true;
                        }
                    }
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                }else{
                    Tips.showTips(re.msg);
                } 
            })
        };

        $scope.getData();       

        // 评论
        $scope.comment = function(){
            httpRequest.postWithAuth($scope, "doctor/api/CommentArticle", {article_id: $scope.id, content: $scope.comment_content}, function(re){
              re = re.data;
                if(!re.code){
                  Tips.showTips("评论发表成功！");
                  $scope.getData();
                  $scope.comment_content = "";
                }else{
                  Tips.showTips(re.msg);
                }
          })
        };

        //滑动事件
        $scope.load_more = function(){     
            $scope.timestamp = Math.ceil($scope.data[$scope.data.length - 1].timestamp/1000);
            $scope.getData();
        };

    }]);
});