define(['app'],function (app) {
    app.controller('consultCtrl', ['$scope', 'httpRequest','Storage', '$ionicPopup', '$cordovaGeolocation', function($scope, httpRequest, Storage, $ionicPopup, $cordovaGeolocation) {
        $scope.$on('$ionicView.afterEnter', function() {
            if (location.hash == "#/tab/infomation" || location.hash == "#/tab/mine" || location.hash == "#/tab/consult") {
                var tabs =document.getElementsByTagName('ion-tabs');
                angular.element(tabs).removeClass("tabs-item-hide");
            }

            getUserNumber();
            getUserData();
        });

        $scope.$on('$ionicView.beforeLeave', function() {
            if (location.hash == "#/tab/infomation" || location.hash == "#/tab/mine" || location.hash == "#/tab/consult") return;
            var tabs =document.getElementsByTagName('ion-tabs');
            angular.element(tabs).addClass("tabs-item-hide");
        });

        // 上传医生的位置
        var posOptions = {timeout: 8000, enableHighAccuracy: false};
        $cordovaGeolocation.getCurrentPosition(posOptions).then(function (position) {
            var lat  = position.coords.latitude;
            var long = position.coords.longitude;
            httpRequest.postWithAuth($scope, "/doctor/api/SetLocation", {longitude:long, latitude:lat}, function (re){
            });
        });

        // 获取服务信息
        httpRequest.getWithAuth($scope, "/doctor/api/DoctorConsultService", {}, function (re){
            $scope.data = re.data.data;
            if ($scope.data) {
                Storage.set("DM_Consult", re.data.data);
            }
        });

        var getUserNumber = function(){
            $scope.person = {};
            // 获取医生图文咨询个数
            httpRequest.getWithAuth($scope, "/doctor/api/GetIMConsultUsers", {}, function (re){
                $scope.data = re.data.data;
                if ($scope.data) {
                    if($scope.data.users) {
                        $scope.person.pic = $scope.data.users.length;
                    }
                }
            }, function(){}, function(){}, true);

            // 获取医生视频咨询个数
            httpRequest.getWithAuth($scope, "/doctor/api/GetVideoConsultUsers", {}, function (re){
                $scope.data = re.data.data;
                if ($scope.data) {
                    if($scope.data.users) {
                        $scope.person.video = $scope.data.users.length;
                    }
                }
            }, function(){}, function(){}, true);
        };


        var getUserData = function() {
            httpRequest.getWithAuth($scope, "/doctor/api/GetDoctorInfo", {}, function (re) {
                $scope.dataVer = re.data.data;
            }, function () {}, function () {}, true);
        };
        $scope.depandVerify = function(){
            var tmp = "";
            if ($scope.dataVer){
                if($scope.dataVer.verify_status == 1) {
                    tmp = '加急审核中，请耐心等待！';
                } else if($scope.dataVer.verify_status != 2){
                    tmp = "立即认证，开通此功能？";
                }
            } else {
                tmp = "需要登录认证的医生...";
            }
            if(tmp){
                $ionicPopup.alert({
                    title: '温馨提示',
                    template: tmp,
                    buttons: [
                        {
                            text: '<b>确定</b>',
                            type: 'button-balanced'
                        }
                    ]
                }).then(function() {
                    if($scope.dataVer.verify_status == 0 || $scope.dataVer.verify_status == 3) {
                        location.href="#/tab/mine/verify";
                    }
                });
                return true;
            }
            return false;
        };

        $scope.getOfflineList = function(){
            if($scope.depandVerify())return;
            location.href="#/tab/lineList"
        };

        if (!ionic.Platform.is('browser')){
            // 进来的时候初始化环信....
            var auth = Storage.get("DM_Auth");
            var params = {
                key:"kangbaomu#kangbaomu"
            };
            var dmplug = window.dmhuanxin;
            dmplug.init(params, function(args){}, function(err){});

            // 进入聊天页面
            $scope.getContactList = function(){
                if($scope.depandVerify())return;
                var auth = Storage.get("DM_Auth");
                var convers = {
                    user:auth.easemob_username,
                    psw:auth.easemob_password,
                    uid:auth.doctor_id,
                    token:auth.token,
                    type:"DMKBMIMTypeNormal",
                    role:"DMKBMRoleDoctor",
                    avatar_url:auth.avatar_url
                };
                dmplug.conversation(convers, function(re){}, function(re){});
            };

            // 进入视频页面
            $scope.getVedioList = function(){
                if($scope.depandVerify())return;
                var auth = Storage.get("DM_Auth");
                var convers = {
                    user:auth.easemob_username,
                    psw:auth.easemob_password,
                    uid:auth.doctor_id,
                    token:auth.token,
                    type:"DMKBMIMTypeVedio",
                    role:"DMKBMRoleDoctor",
                    avatar_url:auth.avatar_url
                };
                dmplug.conversation(convers, function(re){}, function(re){});
            };
        }

    }]);

});

