define(['app', 'js/utils/tips'], function(app, Tips) {
    app.controller('infoDetailsCtrl', ['$scope', 'Storage', '$ionicHistory', 'httpRequest', '$state', '$sce', '$cordovaInAppBrowser', '$ionicModal',
        function($scope, Storage, $ionicHistory, httpRequest, $state, $sce, $cordovaInAppBrowser, $ionicModal) {
            $scope.pageTitle = '通知详情';
            $scope.$on("$ionicView.beforeEnter", function() {
                var dm_auth = $scope.dm_auth = Storage.get('DM_Auth');
                $scope.$emit('loadding', 'noBackdrop', '加载中...');
                httpRequest.get('doctor/api/GetDoctorNoticeContent', {
                    token: dm_auth.token,
                    doctor_id: dm_auth.doctor_id,
                    id: $state.params.id
                }, function(re, data) {
                    if (data.code == 0) {
                        $scope.content = $sce.trustAsHtml(data.data.content);
                    } else {
                        Tips.showTips(data.msg);
                    }
                }, onFailed, onFinal);
            })
            $scope.back = function() {
                $ionicHistory.goBack();
            }

            function onFailed(re) {
                if (re.status != 200) {
                    Tips.showTips('亲~您好像断网了，请检查您的网络~~~');
                }
            }

            function onFinal(re) {
                $scope.$emit('loadding', 'false');
            }
            //处理a标签外链跳转
            function a_click(e) {
                var target = e.target;
                if (target.tagName == 'A' && target.href.indexOf('http') > -1) {
                    e.preventDefault();
                    var url = target.href;
                    $scope.modal = $ionicModal.fromTemplate("<ion-modal-view><ion-header-bar align-title=\"center\" class=\"bar-balanced\"><h1 class=\"title\">" + target.innerHTML + "</h1>    <a class=\"button\" ng-click=\"hideModal()\">\u5173\u95ED</a></ion-header-bar><ion-content scroll=\"true\" overflow-scroll=\"true\">    <iframe style=\"width:100%;height:100%;overflow:scroll;\" src=\"" + url + "\" frameborder=\"0\"></iframe></ion-content></ion-modal-view>", {
                        scope: $scope,
                        animation: "slide-in-left"
                    })
                    $scope.modal.show();
                }
            }
            $scope.hideModal = function() {
                $scope.modal.hide();
                $scope.modal && $scope.modal.remove();
            }
            angular.element(document).on('click', a_click);
            $scope.$on("$destroy", function() {
                angular.element(document).off('click', a_click);
                $scope.modal && $scope.modal.remove();
            });
        }
    ]);
});