define(['app','js/utils/tips'],function (app,Tips) {
    app.controller('infomationCtrl', ['$scope' , 'httpRequest', '$ionicSlideBoxDelegate', function($scope, $h, $ionicSlideBoxDelegate) {

        $scope.$on('$ionicView.afterEnter', function() {
            if (location.hash == "#/tab/infomation" || location.hash == "#/tab/mine" || location.hash == "#/tab/consult") {
                var tabs =document.getElementsByTagName('ion-tabs');
                angular.element(tabs).removeClass("tabs-item-hide");
            }
        });
        $scope.$on('$ionicView.beforeLeave', function() {
            if (location.hash == "#/tab/infomation" || location.hash == "#/tab/mine" || location.hash == "#/tab/consult") return;
            var tabs =document.getElementsByTagName('ion-tabs');
            angular.element(tabs).addClass("tabs-item-hide");
        });

        // 获取分类接口
      $scope.$emit('loadding', 'noBackdrop','加载中...');
      $h.get("doctor/api/GetArticleCategories",{},function(re,data){
        if(data.code == 0) {
          $scope.categories = data.data.categories;
          $scope.cur_id = $scope.categories[0].id;
          $scope.postData = {category_id: $scope.cur_id, count: 10,before_timestamp:parseInt(+new Date()/1000) };
          $scope.before_timestamp = parseInt(+new Date()/1000);
          $scope.getList();
        } else {
          Tips.showTips(data.msg);
        }
      },onFailed,onFinal);

      // 切换分类
      $scope.change = function(id){
        $scope.cur_id = id;
        $scope.banner = [];
        $scope.normal_articles = [];
        $scope.before_timestamp = parseInt(+new Date()/1000);
        $scope.moreDataCanBeLoaded = true;
        $scope.getList();
      };
      $scope.moreDataCanBeLoaded = false;
      $scope.banner = [];
      $scope.normal_articles = [];
      // 根据分类获取文章列表
      $scope.getList = function(mybool){
        var postData = angular.extend({},$scope.postData,{category_id:$scope.cur_id},{before_timestamp:$scope.before_timestamp});
        $h.get("doctor/api/GetArticleList", postData,function(xhr, re){
          if(re.code == 0) {
            if(!mybool){
              $scope.normal_articles = [];
            }
            $scope.banner = re.data.banner_articles;
            $ionicSlideBoxDelegate.loop(true);
            $ionicSlideBoxDelegate.update();
            var normal_articles  = re.data.normal_articles;
            var len = normal_articles.length;
            if(len < 10) {
              $scope.moreDataCanBeLoaded = false;
            } else {
              $scope.moreDataCanBeLoaded = true;
              $scope.before_timestamp = parseInt(normal_articles[len-1].updated_timestamp/1000);
            }
            for (var i = 0; i < len; i++) {
                $scope.normal_articles.push(normal_articles[i]);
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
          } else {
            Tips.showTips(re.msg);
          }
        },onFailed)
      }

      function onFailed(re) {
        if(re.status != 200) {
          Tips.showTips('亲~您好像断网了，请检查您的网络~~~');
        }
      }
      function onFinal(re) {
        $scope.$emit('loadding', 'false');
      }
    }]);
});

