define(['app', 'js/utils/tips'], function(app, Tips) {
    app.controller('informDetailCtrl', ['$scope', '$state', 'httpRequest', '$ionicActionSheet', 'Storage', '$cordovaInAppBrowser','$ionicModal' , function($scope, $state, httpRequest, $ionicActionSheet, Storage, $cordovaInAppBrowser, $ionicModal) {
        $scope.$emit('loadding', 'noBackdrop', '加载中...');
        $scope.id = $state.params.id;
        // 获取文章详情
        httpRequest.getWithAuth($scope, "doctor/api/GetArticleContent", {
                article_id: $scope.id
            }, function(re) {
                re = re.data;
                if (!re.code) {
                    $scope.data = re.data;
                    $scope.data.content = $sce.trustAsHtml(re.data.content);
                } else {
                    Tips.showTips(re.msg);
                }
            }, onFailed, onFinal)
            // 判断用户是否已点赞
        httpRequest.getWithAuth($scope, 'doctor/api/GetArticleLikeStatus', {
                article_id: $scope.id
            }, function(re) {
                re = re.data;
                if (!re.code) {
                    $scope.like_status = re.data.like_status;
                } else {}
            }, onFailed, onFinal)
            // 获取文章点赞数
        httpRequest.getWithAuth($scope, 'doctor/api/GetArticleLikesCount', {
                article_id: $scope.id
            }, function(re) {
                re = re.data;
                if (!re.code) {
                    $scope.like_count = re.data.count;
                } else {}
            }, onFailed, onFinal)
        //     // 获取文章评论数
        httpRequest.getWithAuth($scope, 'doctor/api/GetArticleCommentsCount', {
            article_id: $scope.id
        }, function(re) {
            re = re.data;
            if (!re.code) {
                $scope.comments_count = re.data.comments_count;
            } else {}
        }, onFailed, onFinal);
        // 分享
        $scope.share = function() {
            return; // 暂时不支持
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                        text: '<div class="goods-share"><i class="icon icon-weixin goods-share-wx"></i>分享给微信好友</div>'
                    }, {
                        text: '<div class="goods-share"><i class="icon icon-wxfrends goods-share-wxfrends"></i>分享给微信朋友圈</div>'
                    }
                    //    , {
                    //    text: '<div class="goods-share"><i class="icon icon-qq goods-share-qq"></i>分享给QQ好友</div>'
                    //}, {
                    //    text: '<div class="goods-share"><i class="icon icon-qzone goods-share-qzone"></i>分享到QQ空间</div>'
                    //}, {
                    //    text: '<div class="goods-share"><i class="icon icon-weibo goods-share-weibo"></i>分享到新浪微博</div>'
                    //}
                ],
                buttonClicked: function(index) {
                    switch (index) {
                        case 0:
                            share('wx');
                            break;
                        case 1:
                            share('wx_circle');
                            break;
                        case 2:
                            share('qq');
                            break;
                        case 3:
                            share('qzone');
                            break;
                        case 4:
                            share('sina');
                            break;
                    }
                }
            });
        };

        function share(type) {
            var data = {
                "title": $scope.data.title,
                "content": "来自康保姆的分享",
                "imgUrl": "http://static.kangbm.com//u/14/fa5e2e47-a341-4836-a5d2-6986b0c22132.jpg",
                "targetUrl": ""
            };
            dmwechat.share(type, data, function(re) {}, function(re) {})
        }
        // 评论
        $scope.comment = function() {
            httpRequest.postWithAuth($scope, "doctor/api/CommentArticle", {
                article_id: $scope.id,
                content: $scope.comment_content
            }, function(re) {
                re = re.data;
                if (re.code == 0) {
                    Tips.showTips("评论发表成功！");
                    $scope.comments_count++;
                    $scope.comment_content = "";
                } else {
                    Tips.showTips(re.msg);
                }
            })
        };
        // 点赞
        $scope.like = function() {
            httpRequest.postWithAuth($scope, 'doctor/api/ArticleLike', {
                article_id: $scope.id,
                like: $scope.like_status ? 0 : 1
            }, function(re) {
                re = re.data;
                if (re.code == 0) {
                    $scope.like_status = $scope.like_status ? 0 : 1;
                    $scope.like_count = $scope.like_status ? $scope.like_count + 1 : $scope.like_count - 1;
                    var msg = $scope.like_status ? "点赞成功！" : "取消点赞成功！";
                    Tips.showTips(re.msg);
                } else {
                    Tips.showTips(re.msg);
                }
            });
        };

        function onFailed(re) {
            if (re.status != 200) {
                Tips.showTips('亲~您好像断网了，请检查您的网络~~~');
            }
        }

        function onFinal(re) {
            $scope.$emit('loadding', 'false');
        }
        $scope.$on('$ionicView.beforeEnter', function() {
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
                cordova.plugins.Keyboard.disableScroll(false);
            }
        });
        //处理a标签外链跳转
        function a_click(e) {
            var target = e.target;
            if (target.tagName == 'A' && target.href.indexOf('http') > -1) {
                e.preventDefault();
                var url = target.href;
                $scope.modal = $ionicModal.fromTemplate("<ion-modal-view><ion-header-bar align-title=\"center\" class=\"bar-balanced\"><h1 class=\"title\">" + target.innerHTML + "</h1>    <a class=\"button\" ng-click=\"hideModal()\">\u5173\u95ED</a></ion-header-bar><ion-content scroll=\"true\" overflow-scroll=\"true\">    <iframe style=\"width:100%;height:100%;overflow:scroll;\" src=\"" + url + "\" frameborder=\"0\"></iframe></ion-content></ion-modal-view>", {
                    scope: $scope,
                    animation: "slide-in-left"
                })
                $scope.modal.show();
            }
        }
        $scope.hideModal = function() {
            $scope.modal.hide();
            $scope.modal && $scope.modal.remove();
        }
        angular.element(document).on('click', a_click);
        $scope.$on("$destroy", function() {
            angular.element(document).off('click', a_click);
            $scope.modal && $scope.modal.remove();
        });
    }]);
});