define(['app', 'js/utils/tips'],function (app, Tips) {
    app.controller('loginCtrl', ['$scope','$ionicPopup','$compile', 'httpRequest', 'Storage', function($scope, $ionicPopup, $compile, httpRequest, Storage) {
        $scope.user = {
            phone:'',
            psw:''
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            if (Storage.get("DM_Auth")) location.href = "#/tab/consult";

            // 设置键盘跟随....
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);
            }
        });

        $scope.login = function() {
            var user_name = $scope.user.phone,
                password = $scope.user.psw;
            if (!user_name || user_name == '') {
                Tips.showTips('手机号不能为空');
                return;
            }
            if (!password || password == '') {
                Tips.showTips('密码不能为空');
                return;
            }

            $scope.$emit('loadding', 'noBackdrop','请求中...');
            httpRequest.get("/doctor/api/Login",{'phone':$scope.user.phone, 'password':$scope.user.psw},function(re){
                Tips.showTips(re.data.msg);
                if (re.data.code == 0) {
                    Storage.set("DM_Auth", re.data.data);
                    // 跳到主页
                    location.href = "#/tab/consult";
                }
            }, function(re){
                if(re.status != 200) {
                    Tips.showTips('亲~您好像断网了，请检查您的网络~~~');
                }
            }, function(){
                $scope.$emit('loadding', 'false');
            });
        };

        /// 认证登录插件
        $scope.wechat = function() {
            if (!ionic.Platform.isWebView()) {
                var dmplug = window.dmwechat;
                dmplug.login("wechat", function(args){
                    alert(args.access_token);
                }, function(err){
                    alert(err);
                });
            }
        };
        $scope.tencent = function() {
            var dmplug = window.dmwechat;
            dmplug.login("tecent", function(args){
                alert(args.access_token);
                alert(args.userid);
            }, function(err){
                alert(err);
            });
        };
        $scope.sina = function() {
            var dmplug = window.dmwechat;
            dmplug.login("sina", function(args){
                alert(args.access_token);
                alert(args.userid);
            }, function(err){
                alert(err);
            });
        };

        $scope.showPassword = function() {
            $scope.show_psd = !$scope.show_psd
        }


    }]);
});