define(['app'],function (app) {
    app.controller('mineCtrl', ['$scope', 'httpRequest', 'Storage', '$ionicPopup', function($scope, httpRequest, Storage, $ionicPopup) {
        $scope.$on('$ionicView.afterEnter', function() {
            if (location.hash == "#/tab/infomation" || location.hash == "#/tab/mine" || location.hash == "#/tab/consult") {
                var tabs =document.getElementsByTagName('ion-tabs');
                angular.element(tabs).removeClass("tabs-item-hide");
            }

            $scope.getMineMsg();
        });
        $scope.$on('$ionicView.beforeLeave', function() {
            if (location.hash == "#/tab/infomation" || location.hash == "#/tab/mine" || location.hash == "#/tab/consult") return;
            var tabs =document.getElementsByTagName('ion-tabs');
            angular.element(tabs).addClass("tabs-item-hide");
        });

        // 修改登陆状态
        if (Storage.get("DM_UserData")) {
            $scope.data = Storage.get("DM_UserData");
        } else {
            $scope.data = {
                "avatar_url":"img/default.png"
            };
        }

        $scope.getMineMsg = function(){
            httpRequest.postWithAuth($scope, "/doctor/api/GetDoctorInfo", {}, function(re){
                if (re.data.code == 0) {
                    $scope.data = re.data.data;
                    if (!$scope.data.avatar_url) $scope.data.avatar_url = "img/default.png";
                    Storage.set("DM_UserData", re.data.data);

                    //审核未通过的时候提示...
                    if ($scope.data.verify_status == 3) {
                        $ionicPopup.alert({
                            title: '审核未通过',
                            template: '原因:'+re.data.data.verify_message,
                            buttons: [
                                {
                                    text: '<b>确定</b>',
                                    type: 'button-balanced'
                                }
                            ]
                        });
                    }
                }
            });
        };

        // 跳转，判断审核的情况
        $scope.transform = function(index) {
            if ($scope.data) {
                if ($scope.data.verify_status == 2) {
                    if(index == 0) {
                        location.href="#/tab/mine/service";
                    } else if (index == 1) {
                        location.href="#/tab/mine/assistant";
                    } else if (index == 2) {
                        location.href="#/tab/mine/acount";
                    } else if (index == 3) {
                        location.href="#/tab/mine/invitecode";
                    } else if (index == 4) {
                        location.href="#/tab/mine/verify";
                    }
                    return;
                } else if ($scope.data.verify_status == 1) {
                    $ionicPopup.alert({
                        title: '温馨提示',
                        template: '加急审核中，请耐心等待！',
                        buttons: [
                            {
                                text: '<b>确定</b>',
                                type: 'button-balanced'
                            }
                        ]
                    });
                    return;
                }
            }
            $ionicPopup.confirm({
                title: '立即认证，开通此功能？',
                buttons: [
                    { text: '取消'},
                    {
                        text: '<b>确定</b>',
                        type: 'button-balanced',
                        onTap: function() {
                            return true;
                        }
                    }
                ]
            }).then(function(res) {
                if(res) {
                    location.href="#/tab/mine/verify";
                }
            });
        }
    }]);
});
    
