
define(['app', 'js/utils/tips'],function (app, Tips) {
    app.controller('offlineCtrl', ['$scope','Storage','$ionicHistory','Storage','httpRequest', '$cordovaGeolocation',
        function($scope, Storage, ionicHistory, Storage, httpRequest, $cordovaGeolocation) {

        var posOptions = {timeout: 10000, enableHighAccuracy: false};
        $cordovaGeolocation.getCurrentPosition(posOptions).then(function (position) {
            $scope.lat  = position.coords.latitude;
            $scope.long = position.coords.longitude;
        }, function(err) {
            // error
            Tips.showTips("无法获取到地理位置...");

            // 设置默认地理位置在广州...
            $scope.lat  = 113.2759952545166;
            $scope.long = 23.117055306224895;
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            var address = "";
            if(Storage.get("DM_Address"))address = "已选择";
            $scope.data.address = address;
        });

        $scope.data = {
            longitude:"",
            latitude:"",
            status: 0,
            price: '',
            consults_per_hour: ''
        };
        var data = Storage.get("DM_Consult");
        if (data) {
            $scope.data.price = data.consult_offline.price;
            $scope.data.status = !!data.consult_offline.status;
        } else {
            $scope.data.price = "";
            $scope.data.status = 0;
        };

        var cph = Storage.get("DM_Cph");
        if(data){
            $scope.data.consults_per_hour = cph;
        }else{
            $scope.data.consults_per_hour = '';
        }

        $scope.save = function(){
            var address = '';
            if(Storage.get("DM_Address")){
                address = Storage.get("DM_Address").area.split('，').join('')+Storage.get("DM_Address").address;
            }

            var tmp = "";
            if(!$scope.data.price)tmp = "请输入价格";
            if(!address)tmp = "请输入线下地址";
            if(!$scope.data.consults_per_hour)tmp = "请输入小时人次";
            if(tmp){
                alert(tmp);
                return;
            }

            var data = {
                price:$scope.data.price,
                address:address,
                status: +$scope.data.status,
                longitude:$scope.long,
                latitude:$scope.lat,
                consults_per_hour:$scope.data.consults_per_hour,
                mon:Storage.get("DM_WeekData_0"),
                tue:Storage.get("DM_WeekData_1"),
                wed:Storage.get("DM_WeekData_2"),
                thu:Storage.get("DM_WeekData_3"),
                fri:Storage.get("DM_WeekData_4"),
                sat:Storage.get("DM_WeekData_5"),
                sun:Storage.get("DM_WeekData_6")
            };
            httpRequest.postWithAuth($scope, "/doctor/api/SetOfflineService", data, function(re){
                if (re.data.code == 0) {
                    // save
                    Storage.set("DM_Cph", $scope.data.consults_per_hour);
                    var data = Storage.get("DM_Consult");
                    if (data) {
                        data.consult_offline.price = $scope.data.price;
                        data.consult_offline.status = +$scope.data.status;
                    }else{
                        var data = {
                            "consult_im":{  // 图文咨询
                                "status":0,  //0:关闭 1:开启
                                "price":'',
                                "consults_per_hour":''
                            },
                            "consult_video":{ //视频咨询
                                "status":0,  //0:关闭 1:开启
                                "price":'',
                                "consults_per_hour":''
                            },
                            "consult_offline":{  //线下咨询
                                price: $scope.data.price,
                                status: +$scope.data.status
                            }
                        }
                    }
                    Storage.set("DM_Consult", data);

                    ionicHistory.goBack();
                }
            })
        }

    }]);
});

