define(['app', 'js/utils/tips'], function(app, Tips) {
    app.controller('verifyCtrl', ['$scope', 'Storage','$cordovaCamera','$cordovaImagePicker', 'httpRequest','$ionicActionSheet','$q', '$ionicHistory',
        function($scope, Storage, $cordovaCamera, $cordovaImagePicker, httpRequest, $ionicActionSheet,$q, $ionicHistory) {
        $scope.$on('$ionicView.beforeEnter', function() {
            // get msg from personal msg
            var room = Storage.get("DM_Room");
            if (room) $scope.data.room = "已选择";
            if (Storage.get("DM_Position")) $scope.data.position = Storage.get("DM_Position");
            if (Storage.get("DM_Academic")) $scope.data.academic = Storage.get("DM_Academic");
            if (Storage.get("DM_Speciality")) $scope.data.speciality = Storage.get("DM_Speciality");
            if (Storage.get("DM_Education")) $scope.data.education = Storage.get("DM_Education");
        });

        $scope.msg = {
            name:"",
            hospital:"",
            teacher:"",
            teacher_id:""
        };

        if (Storage.get("DM_Name")) {
            $scope.msg.name = Storage.get("DM_Name");
        }
        if (Storage.get("DM_Hospital")) {
            $scope.msg.hospital = Storage.get("DM_Hospital");
        }

        $scope.imgs = ["img/addportrait.png", "img/addportrait.png", "img/addportrait.png", "img/addportrait.png"];
        $scope.imgsUrl = ["", "", "", ""];


        // 初始化数据
        var auth = Storage.get("DM_Auth");
        $scope.data = {};
        if(auth) {
            if (auth.good_at){
                $scope.data.speciality = auth.good_at;
            }
            if (auth.achievement){
                $scope.data.academic = auth.achievement;
            }
            if (auth.title_certificate_url){
                $scope.imgsUrl[2] = auth.title_certificate_url;
                $scope.imgs[2] = auth.title_certificate_url;
            }
            if (auth.title){
                $scope.data.position = auth.title;
            }
            if (auth.education_background){
                $scope.data.education = auth.education_background;
            }
            if (auth.achievement){
                $scope.data.education = auth.achievement;
            }
            if (auth.id_card_url){
                $scope.imgsUrl[1] = auth.id_card_url;
                $scope.imgs[1] = auth.id_card_url;
            }
            if (auth.doctor_certificate_url){
                $scope.imgsUrl[3] = auth.doctor_certificate_url;
                $scope.imgs[3] = auth.doctor_certificate_url;
            }
            if (auth.avatar_url){
                $scope.imgsUrl[0] = auth.avatar_url;
                $scope.imgs[0] = auth.avatar_url;
            }
            if (auth.doctor_name){
                $scope.msg.name = auth.doctor_name;
            }
            if (auth.hospital){
                $scope.msg.hospital = auth.hospital;
            }
            if (auth.doctor_name){
                $scope.msg.teacher = auth.doctor_name;
            }
            if (auth.doctor_phone){
                $scope.msg.teacher_id = auth.doctor_phone;
            }
        }

        // 获取缓存图片信息
        var storeArr = ["DM_avatar_url", "DM_id_card_url", "DM_title_certificate_url", "DM_doctor_certificate_url"];
        for (var a=0;a<storeArr.length;a++) {
            var img = Storage.get(storeArr[a]);
            if (img){
                $scope.imgs[a] = img;
                $scope.imgsUrl[a] = img;
            }
        }

        // 修改类型
        $scope.changeType = function() {
            $scope.nurse = !$scope.nurse;
        };

        // 选择照片
        var tmpTarget = "";
        $scope.showImgPop = function(index) {
            tmpTarget = index;
            $ionicActionSheet.show({
                buttons: [
                    { text: '<div class="c-6 text-center">相册</div>' },
                    { text: '<div class="c-6 text-center">拍照</div>' },
                    { text: '<div class="c-6 text-center">取消</div>' }
                ],
                buttonClicked: function(index) {
                    if(index == 0) {
                        $scope.imgPicker();
                    } else if(index == 1) {
                        $scope.takePic();
                    }
                    return true;
                }
            });
        };
        // 拍照获取
        $scope.takePic = function() {
            var options = {
                quality: 80,
                destinationType: Camera.DestinationType.DATA_URL,
                sourceType: Camera.PictureSourceType.CAMERA,
                allowEdit: true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 120,
                targetHeight: 120,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: false,
                correctOrientation:true
            };
            $cordovaCamera.getPicture(options).then(function(imageData) {
                if (imageData) {
                    $scope.imgs[tmpTarget] = "data:image/png;base64, "+imageData;
                }
            }, function(err) {
                Tips.showTips("获取图片失败了.");
            });
        };
        // 选择图片
        $scope.imgPicker = function() {
            var options = {
                maximumImagesCount: 1,
                width: 800,
                height: 800,
                quality: 80
            };
            $cordovaImagePicker.getPictures(options)
                .then(function (results) {
                    if (results[0]) {
                        $scope.imgs[tmpTarget] = results[0];
                    }
                }, function(error) {
                    Tips.showTips("获取图片失败了.");
                });
        };

        // 取消照片
        $scope.cancelImg = function(index){
            $scope.imgs[index] = "img/addportrait.png";
        };

        // 确定信息提交...
        $scope.comfirm = function() {
            var a = 0;
            uploadImgs(a);
        };

        var checkeURL = function(str){
            //在JavaScript中，正则表达式只能使用"/"开头和结束，不能使用双引号 
            var Expression=/http(s)?:////([\w-]+\.)+[\w-]+(\/[\w- .\/?%&=]*)?/; 
            var objExp=new RegExp(Expression); 
            if(str.indexOf("localhost")){ 
                str = str.replace("localhost","127.0.0.1"); 
            } 
            if(objExp.test(str)==true){ 
                return true; 
            }else{
                return false; 
            } 
        }
        // 遍历提交图片，判断类型，如果是医生，提交四张，如果是护士提交两张
        var uploadImgs = function(a) {
            if (checkeURL($scope.imgs[a])) {
                contssFiles(a);
            }
            httpRequest.postFileWithAuth($scope, $scope.imgs[a], function(re){
                Tips.showTips("正在上传第"+a+"张图片...");
                if (re.code == 0) {
                    contssFiles(a, re);
                }
            })
        };
        var contssFiles = function(a, data){
            if(data) $scope.imgsUrl[a] = data.data.url;
            a += 1;
            if ($scope.nurse) {
                if (a < 2) {
                    uploadImgs(a);
                    return;
                }
            } else {
                if (a < 4) {
                    uploadImgs(a);
                    return;
                }
            }
            uploadMsg();
        };

        // 提交用戶信息
        var uploadMsg = function() {
            // 先验证数据的正确性
            var msg = "";
            if(!Storage.get("DM_Room"))msg = "请先选择科室";
            if(!$scope.data.position)msg = "请先选择职称";
            if(!$scope.data.speciality)msg = "请先输入擅长信息";
            if(!$scope.msg.hospital && !$scope.nurse)msg = "请先输入所在医院";
            if(!$scope.data.academic)msg = "请先输入学术信息";
            if(!$scope.data.education)msg = "请先输入教育信息";
            if(msg){
                Tips.showTips(msg);
                return;
            }

            var request = {
                name:$scope.msg.name,
                department_id:Storage.get("DM_Room"),
                title:$scope.data.position,
                good_at:$scope.data.speciality,
                education_background:$scope.data.academic,
                achievement:$scope.data.education,
                avatar_url:$scope.imgsUrl[0],
                id_card_url:$scope.imgsUrl[1]
            };
            var url = "/doctor/api/DoctorIdentification";
            if ($scope.nurse) {
                url = "/doctor/api/AssistantIdentification";
                request.doctor_name = $scope.msg.teacher;
                request.doctor_phone = $scope.msg.teacher_id;
            } else {
                request.hospital = $scope.msg.hospital;
                request.title_certificate_url = $scope.imgsUrl[2];
                request.doctor_certificate_url = $scope.imgsUrl[3];
            }
            httpRequest.postWithAuth($scope, url, request, function(re){
                if (re.data.code == 0) {
                    // 这里已经审核通过了，修改添加一下照片什么的...
                    Storage.set("DM_Name", $scope.msg.name);
                    Storage.set("DM_Hospital", $scope.msg.hospital);
                    Storage.set("DM_avatar_url", $scope.imgsUrl[0]);
                    Storage.set("DM_id_card_url", $scope.imgsUrl[1]);
                    Storage.set("DM_title_certificate_url", $scope.imgsUrl[2]);
                    Storage.set("DM_doctor_certificate_url", $scope.imgsUrl[3]);

                    $ionicHistory.goBack();
                }
            });
        }

    }]);
});
    
