define(['app'],function (app) {
    app
        .config(function($stateProvider, $urlRouterProvider) {
            // Override the internal 'views' builder with a function that takes the state
            // definition, and a reference to the internal function being overridden:
            $stateProvider.decorator('views', function(state, parent) {
                var result = {}, views = parent(state);
                //var head = "http://192.168.1.48:8081/kangbaomu/doctor/www/";
                var head = "";
                angular.forEach(views, function(config, name) {
                    config.controllerUrl = head+config.controllerUrl;
                    config.templateUrl = head+config.templateUrl;
                    result[name] = config;
                });
                return result;
            });

            $stateProvider
                .state('index', {    //首页
                    url: '/index',
                    templateUrl:"templates/login.html",
                    controller: "loginCtrl",
                    controllerUrl: 'js/controllers/login.js'
                })

                .state('login', {      //登录
                    url: '/login',
                    templateUrl:"templates/login.html",
                    controller: "loginCtrl",
                    controllerUrl: 'js/controllers/login.js'
                })
                .state('register', {      //注册
                    url: '/register',
                    templateUrl:"templates/register.html",
                    controllerUrl: 'js/controllers/register.js',
                    controller: "registerCtrl"
                })
                .state('findpsw', {      //注册
                    url: '/findpsw',
                    templateUrl: "templates/findpsw.html",
                    controllerUrl: 'js/controllers/findpsw.js',
                    controller: "findpswCtrl"
                })

                // setup an abstract state for the tabs directive
                .state('tab', {
                    url: '/tab',
                    abstract: true,
                    templateUrl: 'templates/tabs.html'
                })

                // Each tab has its own nav history stack:
                .state('tab.consult', {
                    url: '/consult',
                    views: {
                        'tab-consult': {
                            templateUrl: 'templates/consult.html',
                            controller: 'consultCtrl',
                            controllerUrl: 'js/controllers/consult.js'
                        }
                    }
                })
                    .state('tab.msgList', {
                        url: '/msgList',
                        views: {
                            'tab-consult': {
                                templateUrl: 'templates/msgList.html',
                                controller: 'msgListCtrl',
                                controllerUrl: 'js/controllers/msgList.js'
                            }
                        }
                    })
                    .state('tab.videoList', {
                        url: '/videoList',
                        views: {
                            'tab-consult': {
                                templateUrl: 'templates/videoList.html',
                                controller: 'videoListCtrl',
                                controllerUrl: 'js/controllers/videoList.js'
                            }
                        }
                    })
                    .state('tab.lineList', {
                        url: '/lineList',
                        views: {
                            'tab-consult': {
                                templateUrl: 'templates/lineList.html',
                                controller: 'lineListCtrl',
                                controllerUrl: 'js/controllers/lineList.js'
                            }
                        }
                    })
                        .state('tab.lineListHistory', {
                            url: '/lineListHistory',
                            views: {
                                'tab-consult': {
                                    templateUrl: 'templates/lineListHistory.html',
                                    controller: 'lineListHistoryCtrl',
                                    controllerUrl: 'js/controllers/lineListHistory.js'
                                }
                            }
                        })
                            .state('tab.lineListDetail', {
                                url: '/lineList/:id',
                                views: {
                                    'tab-consult': {
                                        templateUrl: 'templates/lineListDetail.html',
                                        controller: 'lineListDetailCtrl',
                                        controllerUrl: 'js/controllers/lineListDetail.js'
                                    }
                                }
                            })
                        .state('tab.videoListHistory', {
                            url: '/videoListHistory',
                            views: {
                                'tab-consult': {
                                    templateUrl: 'templates/videoListHistory.html',
                                    controller: 'videoListHistoryCtrl',
                                    controllerUrl: 'js/controllers/videoListHistory.js'
                                }
                            }
                        })
                        .state('tab.msgListHistory', {
                            url: '/msgListHistory',
                            views: {
                                'tab-consult': {
                                    templateUrl: 'templates/msgListHistory.html',
                                    controller: 'msgListHistoryCtrl',
                                    controllerUrl: 'js/controllers/msgListHistory.js'
                                }
                            }
                        })

                .state('tab.infomation', {
                    url: '/infomation',
                    views: {
                        'tab-infomation': {
                            templateUrl: 'templates/information.html',
                            controller: 'infomationCtrl',
                            controllerUrl: 'js/controllers/infomation.js'
                        }
                    }
                })
                // 资讯详情
                .state('tab.informDetail', {
                    url: '/informDetail/:id',
                    views: {
                        'tab-infomation': {
                            templateUrl: 'templates/informDetail.html',
                            controller: 'informDetailCtrl',
                            controllerUrl: 'js/controllers/informDetail.js'
                        }
                    }
                })
                // 评论详情
                .state('tab.commentDetail', {
                    url: '/commentDetail/:id',
                    views: {
                        'tab-infomation': {
                            templateUrl: 'templates/commentDetail.html',
                            controller: 'commentDetailCtrl',
                            controllerUrl: 'js/controllers/commentDetail.js'
                        }
                    }
                })
                .state('tab.mine', {
                    url: '/mine',
                    views: {
                        'tab-mine': {
                            templateUrl: 'templates/mine.html',
                            controller: 'mineCtrl',
                            controllerUrl: 'js/controllers/mine.js'
                        }
                    }
                })
                    // 认证页面
                    .state('tab.verify', {
                        url: '/mine/verify',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/verify.html',
                                controller: 'verifyCtrl',
                                controllerUrl: 'js/controllers/verify.js'
                            }
                        }
                    })
                        .state('tab.room', {
                            url: '/mine/verify/room',
                            views: {
                                'tab-mine': {
                                    templateUrl: 'templates/room.html',
                                    controller: 'roomCtrl',
                                    controllerUrl: 'js/controllers/room.js'
                                }
                            }
                        })
                        .state('tab.position', {
                            url: '/mine/verify/position',
                            views: {
                                'tab-mine': {
                                    templateUrl: 'templates/position.html',
                                    controller: 'positionCtrl',
                                    controllerUrl: 'js/controllers/position.js'
                                }
                            }
                        })
                        .state('tab.speciality', {
                            url: '/mine/verify/speciality',
                            views: {
                                'tab-mine': {
                                    templateUrl: 'templates/speciality.html',
                                    controller: 'specialityCtrl',
                                    controllerUrl: 'js/controllers/speciality.js'
                                }
                            }
                        })
                        .state('tab.education', {
                            url: '/mine/verify/education',
                            views: {
                                'tab-mine': {
                                    templateUrl: 'templates/education.html',
                                    controller: 'educationCtrl',
                                    controllerUrl: 'js/controllers/education.js'
                                }
                            }
                        })
                        .state('tab.academic', {
                            url: '/mine/verify/academic',
                            views: {
                                'tab-mine': {
                                    templateUrl: 'templates/academic.html',
                                    controller: 'academicCtrl',
                                    controllerUrl: 'js/controllers/academic.js'
                                }
                            }
                        })
                    // 我的服务
                    .state('tab.service', {
                        url: '/mine/service',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/service.html',
                                controller: 'serviceCtrl',
                                controllerUrl: 'js/controllers/service.js'
                            }
                        }
                    })
                        .state('tab.picture', {
                            url: '/mine/service/picture',
                            views: {
                                'tab-mine': {
                                    templateUrl: 'templates/picture.html',
                                    controller: 'pictureCtrl',
                                    controllerUrl: 'js/controllers/picture.js'
                                }
                            }
                        })
                        .state('tab.video', {
                            url: '/mine/service/video',
                            views: {
                                'tab-mine': {
                                    templateUrl: 'templates/video.html',
                                    controller: 'videoCtrl',
                                    controllerUrl: 'js/controllers/video.js'
                                }
                            }
                        })
                        .state('tab.offline', {
                            url: '/mine/service/offline',
                            views: {
                                'tab-mine': {
                                    templateUrl: 'templates/offline.html',
                                    controller: 'offlineCtrl',
                                    controllerUrl: 'js/controllers/offline.js'
                                }
                            }
                        })
                            .state('tab.offaddress', {
                                url: '/mine/service/offaddress',
                                views: {
                                    'tab-mine': {
                                        templateUrl: 'templates/offaddress.html',
                                        controller: 'offaddressCtrl',
                                        controllerUrl: 'js/controllers/offaddress.js'
                                    }
                                }
                            })
                            .state('tab.offtime', {
                                url: '/mine/service/offtime/:id',
                                views: {
                                    'tab-mine': {
                                        templateUrl: 'templates/offtime.html',
                                        controller: 'offtimeCtrl',
                                        controllerUrl: 'js/controllers/offtime.js'
                                    }
                                }
                            })
                    // 我的团队
                    .state('tab.assistant', {
                        url: '/mine/assistant',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/assistant.html',
                                controller: 'assistantCtrl',
                                controllerUrl: 'js/controllers/assistant.js'
                            }
                        }
                    })
                    // 我的账户
                    .state('tab.acount', {
                        url: '/mine/acount',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/acount.html',
                                controller: 'acountCtrl',
                                controllerUrl: 'js/controllers/acount.js'
                            }
                        }
                    })
                        .state('tab.regulation', {
                            url: '/mine/acount/regulation',
                            views: {
                                'tab-mine': {
                                    templateUrl: 'templates/regulation.html',
                                    controller: 'regulationCtrl',
                                    controllerUrl: 'js/controllers/regulation.js'
                                }
                            }
                        })
                            //收入明细
                            .state('tab.property', {
                                url: '/mine/acount/property',
                                views: {
                                    'tab-mine': {
                                        templateUrl: 'templates/property.html',
                                        controller: 'propertyCtrl',
                                        controllerUrl: 'js/controllers/property.js'
                                    }
                                }
                            })
                            //绑定银行
                            .state('tab.bank', {
                                url: '/mine/acount/bank',
                                views: {
                                    'tab-mine': {
                                        templateUrl: 'templates/bank.html',
                                        controller: 'bankCtrl',
                                        controllerUrl: 'js/controllers/bank.js'
                                    }
                                }
                            })
                                // 选择银行
                                .state('tab.selectbank', {
                                    url: '/mine/acount/selectbank',
                                    views: {
                                        'tab-mine': {
                                            templateUrl: 'templates/selectbank.html',
                                            controller: 'selectbankCtrl',
                                            controllerUrl: 'js/controllers/selectbank.js'
                                        }
                                    }
                                })
                            // 提现记录
                            .state('tab.outlayslist', {
                                url: '/mine/acount/outlayslist',
                                views: {
                                    'tab-mine': {
                                        templateUrl: 'templates/outlayslist.html',
                                        controller: 'outlayslistCtrl',
                                        controllerUrl: 'js/controllers/outlayslist.js'
                                    }
                                }
                            })
                            // 提现页面
                            .state('tab.outlays', {
                                url: '/mine/acount/outlays',
                                views: {
                                    'tab-mine': {
                                        templateUrl: 'templates/outlays.html',
                                        controller: 'outlaysCtrl',
                                        controllerUrl: 'js/controllers/outlays.js'
                                    }
                                }
                            })

                    // 我的邀请码
                    .state('tab.invitecode', {
                        url: '/mine/invitecode',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/invitecode.html',
                                controller: 'invitecodeCtrl',
                                controllerUrl: 'js/controllers/invitecode.js'
                            }
                        }
                    })
                    // 客服中心
                    .state('tab.customer', {
                        url: '/mine/customer',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/customer.html',
                                controller: 'customerCtrl',
                                controllerUrl: 'js/controllers/customer.js'
                            }
                        }
                    })
                    // 通知中心
                    .state('tab.notification', {
                        url: '/mine/notification',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/notification.html',
                                controller: 'notificationCtrl',
                                controllerUrl: 'js/controllers/notification.js'
                            }
                        }
                    })
                    // 通知详情
                    .state('tab.infoDetails', {
                        url: '/mine/infoDetails/:id',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/richTpl.html',
                                controller: 'infoDetailsCtrl',
                                controllerUrl: 'js/controllers/infoDetails.js'
                            }
                        }
                    })
                    // 问题反馈
                    .state('tab.callback', {
                        url: '/mine/callback',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/callback.html',
                                controller: 'callbackCtrl',
                                controllerUrl: 'js/controllers/callback.js'
                            }
                        }
                    })
                    // 设置
                    .state('tab.setting', {
                        url: '/mine/setting',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/setting.html',
                                controller: 'settingCtrl',
                                controllerUrl: 'js/controllers/setting.js'
                            }
                        }
                    })
                    // 通用信息内容页
                    .state('tab.content-mine', {
                        url: '/mine/content-mine/:type',
                        views: {
                            'tab-mine': {
                                templateUrl: 'templates/content-mine.html',
                                controller: 'content-mineCtrl',
                                controllerUrl: 'js/controllers/content-mine.js'
                            }
                        }
                    })
                .state('content', {
                    url: '/content/:type',
                    templateUrl: "templates/content-mine.html",
                    controller: "contentCtrl",
                    controllerUrl: 'js/controllers/content.js',
                });
            $urlRouterProvider.otherwise("/index");

        });
});